// Code generated by mockery v2.10.4. DO NOT EDIT.

package mocks

import (
	dao "gitlab.informatika.org/rahmahkn/if3250_2022_03_ensiklo/internal/app/model/dao"
	dto "gitlab.informatika.org/rahmahkn/if3250_2022_03_ensiklo/internal/app/model/dto"

	mock "github.com/stretchr/testify/mock"
)

// CategoryRepo is an autogenerated mock type for the CategoryRepo type
type CategoryRepo struct {
	mock.Mock
}

// CreateCategory provides a mock function with given fields: category
func (_m *CategoryRepo) CreateCategory(category dao.Category) (dao.Category, error) {
	ret := _m.Called(category)

	var r0 dao.Category
	if rf, ok := ret.Get(0).(func(dao.Category) dao.Category); ok {
		r0 = rf(category)
	} else {
		r0 = ret.Get(0).(dao.Category)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(dao.Category) error); ok {
		r1 = rf(category)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteCategory provides a mock function with given fields: categoryId
func (_m *CategoryRepo) DeleteCategory(categoryId dto.DeleteCategoryRequestDTO) error {
	ret := _m.Called(categoryId)

	var r0 error
	if rf, ok := ret.Get(0).(func(dto.DeleteCategoryRequestDTO) error); ok {
		r0 = rf(categoryId)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetAllCategories provides a mock function with given fields:
func (_m *CategoryRepo) GetAllCategories() ([]dao.Category, error) {
	ret := _m.Called()

	var r0 []dao.Category
	if rf, ok := ret.Get(0).(func() []dao.Category); ok {
		r0 = rf()
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]dao.Category)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func() error); ok {
		r1 = rf()
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetCategory provides a mock function with given fields: id
func (_m *CategoryRepo) GetCategory(id uint64) (dao.Category, error) {
	ret := _m.Called(id)

	var r0 dao.Category
	if rf, ok := ret.Get(0).(func(uint64) dao.Category); ok {
		r0 = rf(id)
	} else {
		r0 = ret.Get(0).(dao.Category)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(uint64) error); ok {
		r1 = rf(id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetCategoryByBookId provides a mock function with given fields: id
func (_m *CategoryRepo) GetCategoryByBookId(id uint64) ([]dao.Category, error) {
	ret := _m.Called(id)

	var r0 []dao.Category
	if rf, ok := ret.Get(0).(func(uint64) []dao.Category); ok {
		r0 = rf(id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]dao.Category)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(uint64) error); ok {
		r1 = rf(id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetCategoryByName provides a mock function with given fields: name
func (_m *CategoryRepo) GetCategoryByName(name string) (dao.Category, error) {
	ret := _m.Called(name)

	var r0 dao.Category
	if rf, ok := ret.Get(0).(func(string) dao.Category); ok {
		r0 = rf(name)
	} else {
		r0 = ret.Get(0).(dao.Category)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(string) error); ok {
		r1 = rf(name)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateCategory provides a mock function with given fields: newCategory
func (_m *CategoryRepo) UpdateCategory(newCategory dto.CategoryDTO) (dao.Category, error) {
	ret := _m.Called(newCategory)

	var r0 dao.Category
	if rf, ok := ret.Get(0).(func(dto.CategoryDTO) dao.Category); ok {
		r0 = rf(newCategory)
	} else {
		r0 = ret.Get(0).(dao.Category)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(dto.CategoryDTO) error); ok {
		r1 = rf(newCategory)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}
